#include "../libgnuplot/gplot.h"
#include "../libbild/bild.h"
#include "../libcryst/cryst.h"
#include "../libIPDS/IPDS.h"

#include <libglade-2.0/glade/glade.h>
#include <values.h>
#include <ctype.h>
#include <stdlib.h>
//#include <gnome.h>
#include <gtk/gtk.h>
#include <libgnomecanvas/libgnomecanvas.h>

#ifndef GNOMEIPDS_H
#define GNOMEIPDS_H


#define GNOMONISCH 1
#define PARALLEL 2
#define BASIS_TRAFO 3
#define IPDS_BILD 4
#define REC_MAP 5

#define FIX_METRIK 1
#define FREE_METRIK 2

#define TAKE 1
#define REMOVE 2

typedef struct {
  GtkWidget *app1;
  GtkWidget *dialog1;
  GtkWidget *canvas1;
  GtkWidget *dialog3;
  GtkWidget *dialog4;
  GtkWidget *dialog5;
  GtkWidget *dialog6;
  GtkWidget *dialog7;
  GtkWidget *dialog8;
  GtkWidget *dialog9;
  GtkWidget *dialog10;
  GtkWidget *dialog11;
  GtkWidget *dialog12;
  GtkWidget *dialog13;
  GtkWidget *dialog14;
  GtkWidget *dialog15;
  GtkWidget *dialog16;
  //  GtkWidget *dialog17;
  GtkWidget *window1;
  GtkWidget *meter;
  GtkWidget *file_selector;
  GladeXML *xml;
  GladeXML *xml3;
  GObject *GP;
  GnomeCanvasPoints *points[3];
  GnomeCanvasItem *line[3];
  GnomeCanvasItem *cross[2];
  GnomeCanvasItem *box[4];
  GnomeCanvasItem *circle[21];
  int anzahl_refls;
  GnomeCanvasItem **refl_pos;
  GnomeCanvasItem **refl_pos_circle;
  GnomeCanvasPoints *box_points[4];
  GdkPixbuf *pixbuf;
  guchar *bilddata;
  GnomeCanvasItem *img;
  GnomeCanvasPoints *basis_points[2];
  GnomeCanvasItem *Basis[2];
  GnomeCanvasItem *proj_line[30];
  FILE *shadow_fp;
  int button_pressed;
  int button_count;
  int laue_item_selected;
  int item_selected;
  view_t view[1];
  rec_map_t rec_map[1];
} gnome_t;  

void set_dialog3_handlers (GladeXML *xml, GObject *GP);


// integrate.c
int full_peaksearch (gnome_t *gnome, param_t *param, az_data_t *az_data, az_data_t *az_bg, data_t *view_data,peaksearch_t *peaksearch, trans_table_t *trans_table, datacol_t *datacol, index_param_t *index_param);
int fast_peaksearch_one_plate (gnome_t *gnome, param_t *param, az_data_t *az_data, az_data_t *az_bg, data_t *view_data,peaksearch_t *peaksearch, trans_table_t *trans_table, datacol_t *datacol, index_param_t *index_param);
int do_background_calc (param_t *param, datacol_t *datacol, az_data_t *az_data, az_data_t *az_bg,trans_table_t *trans_table, peaksearch_t *peaksearch, gnome_t *gnome, data_t *view_data );
int do_view_tra (data_t *view_data, az_data_t *az_data, az_data_t *az_bg, trans_table_t *trans_table, param_t *param, gnome_t *gnome, datacol_t *datacol,peaksearch_t *peaksearch );
int integrate (gnome_t *gnome,param_t *param,datacol_t *datacol,trans_table_t *trans_table,peaksearch_t *peaksearch, data_t *view_data, gnomonisch_t *gnomonisch, index_param_t *index_param, metrik_t *metrik, peaks_t *peaks);
int do_full_background (param_t *param,datacol_t *datacol,trans_table_t *trans_table,peaksearch_t *peaksearch);
int do_pulver_integrate(gnome_t *gnome,param_t *param,peaksearch_t *peaksearch,datacol_t *datacol, az_data_t *az_data, az_data_t *az_bg,trans_table_t *trans_table, data_t *view_data);

// matrix_integrate.c
int calc_pos_auf_dieser_platte( int *H, double osc_angle, double stoe_ii_phi, datacol_t *datacol, az_data_t *az_data, trans_table_t *trans_table, int *pos);
int get_bild_info(char *file, datacol_t *datacol, gnome_t *gnome);
void put_into_widget(peak_t *peak, int *pos, double *x_pos,datacol_t *datacol, index_param_t *index_param,gnome_t *gnome);
int matrix_integrate_one_plate (double *om,peaks_t *peaks, datacol_t *datacol,param_t *param, peaksearch_t *peaksearch,gnome_t *gnome, trans_table_t *trans_table, data_t *view_data,index_param_t *index_param);
int do_print_peak_information(gnome_t *gnome, param_t *param, datacol_t *datacol, az_data_t *az_data, peaks_t *peaks_alle, trans_table_t *trans_table, double x_canvas, double y_canvas, index_param_t *index_param, object_list_t *object_list, peaksearch_t *peaksearch);
int simulate_on (param_t *param, datacol_t *datacol, peaks_t *peaks_alle, index_param_t *index_param, peaksearch_t *peakearch, metrik_t  *metrik, gnomonisch_t *gnomonisch, gnome_t *gnome, data_t *view_data, trans_table_t *trans_table, az_data_t *az_data);
void simul_powder (param_t *param, datacol_t *datacol,az_data_t *az_data, az_data_t *az_bg, trans_table_t *trans_table, peaksearch_t *peaksearch );
int do_reflex_profil (gnome_t *gnome, param_t *param, datacol_t *datacol, az_data_t *az_data, az_data_t *az_bg, trans_table_t *trans_table, peaksearch_t *peaksearch);

// metrik.c
int do_view_vektors(datacol_t *datacol, param_t *param);
void parallel_projektion(peaks_t *peaks, double *trafo, double *normal, gnome_t *gnome);
void calc_abstaende (peaks_t *peaks, line_t *linie, int k,gnome_t *gnome, gnomonisch_t *gnomonisch, param_t *param,data_t *view_data);
int project_to_lines(peaks_t *peaks,double *normal, double laengen[3],gnomonisch_t *gnomonisch, gnome_t *gnome, param_t *param, data_t *view_data, index_param_t *index_param);
void input_delauney_cases (gnome_t *gnome, datacol_t *datacol, delos_t *delos);
void update_mehrling_labels (gnome_t *gnome, datacol_t *datacol, peaks_t *peaks, index_param_t *index_param);
void update_delauney_labels (gnome_t *gnome, delos_t *delos);
int update_mehrlings_matrix (gnome_t *gnome, peaks_t *peaks, datacol_t *datacol, index_param_t *index_param,int nummer);
int update_delos_loes(gnome_t *gnome, int anzahl, double indexed, datacol_t *datacol, delos_t *Delos);
void update_lattice (gnome_t *gnome, datacol_t *datacol, param_t *param, index_param_t *index_param, peaks_t *peaks);
int do_d_wert_analyse(index_param_t *index_param, peaks_t *peaks_alle, datacol_t *datacol,int typ, param_t *param, object_list_t *object_list, peaks_t *peaks,az_data_t *az_data, trans_table_t *trans_table,gnome_t *gnome);

// view.c
void clear_canvas(gnome_t *gnome);
void gno_mes (char *message);
void view_data_in_canvas(data_t *data, data_t *view_data, gnome_t *gnome);
void view_lines (int x, int y, gerade_t *gerade, int *index, gnome_t *gnome);
void put_circle_at_pos(double *pos, double radius, gnome_t *gnome, GnomeCanvasItem **circle, char *color);
void make_canvas_cross (gnome_t *gnome, int *pos,int size, az_data_t *az_data,GnomeCanvasItem **cross, char *color);
void create_line (int i, gnome_t *gnome);
void create_rgb (guchar *R, guchar *G, guchar *B);
void rescale_image(data_t *view_data,int skalierung );
void update_bild_canvas(gnome_t *gnome, data_t *view_data);
void do_achsen_beschriftung(GtkWidget *canvas, double pos[2], double faktor[2]) ;
void basis_richtungs_projection(peaks_t *peaks,double min_max[2][2],double **projection,int *anzahl_projections, gnome_t *gnome,gnomonisch_t *gnomonisch,param_t *param);
void view_line_projektion (line_t *linie, double *laengen, int richtung, int l, gnomonisch_t *gnomonisch, gnome_t *gnome);
void view_basis_vektor_in_canvas (gnome_t *gnome, data_t *data, double *om, double radius);
int view_peaks (peaks_t *peaks,data_t *view_data, data_t *data, gnome_t *gnome,gnomonisch_t *gnomonisch,param_t *param, index_param_t *index_param);
void replot(param_t *param, gnome_t *gnome, peaks_t *peaks,gnomonisch_t *gnomonisch, double *om, data_t *data, data_t *view_data,index_param_t *index_param, metrik_t *metrik,datacol_t *datacol, peaksearch_t *peaksearch);
int do_rec_map(param_t *param, gnome_t *gnome, datacol_t *datacol, index_param_t *index_param, trans_table_t *trans_table, rec_map_t *rec_map, data_t *view_data);
void update_run_label(param_t *param, datacol_t *datacol, int *H, gnome_t *gnome, peaksearch_t *peaksearch, view_t *view, az_data_t *az_data, trans_table_t *trans_table);
int calc_peak_and_show(param_t *param,datacol_t *datacol,double *H,gnome_t *gnome,peaksearch_t *peaksearch, view_t *view, az_data_t *az_data, trans_table_t *trans_table);
int show_peak_pos(double osc_angle, int run_nr, int *pos_calc, param_t *param, datacol_t *datacol, az_data_t *az_data, az_data_t *az_bg, data_t *view_data, trans_table_t *trans_table, peaksearch_t *peaksearch, gnome_t *gnome );

// correllation.c
int correllation (param_t *param, gnome_t *gnome, index_param_t *index_param, datacol_t *datacol, metrik_t *metrik, peaksearch_t *peaksearch, peaks_t *peaks, peaks_t *peaks_alle, data_t *view_data, gnomonisch_t *gnomonisch);
void refine_positions(diffs_t *diffs, data_t *data, data_t *view_data, gnome_t *gnome,param_t *param);
int calc_vectors (peaks_t *peaks, trans_t  **trans, datacol_t *datacol, index_param_t *index_param, param_t *param, data_t *view_data, gnome_t *gnome, metrik_t *metrik, diffs_t *alle_diffs);
void check_gnomonisch (diffs_t *alle_diffs, diffs_t *diffs, peaks_t *peaks, datacol_t *datacol, index_param_t *index_param, param_t *param,data_t *view_data, gnome_t *gnome,metrik_t *metrik);


// config.c
void write_config_file (gnome_t *gnome, param_t *param, peaksearch_t *peaksearch, index_param_t *index_param,gnomonisch_t *gnomonisch,datacol_t *datacol, metrik_t *metric);
int get_config (gnome_t *gnome, param_t *param, peaksearch_t *peaksearch, index_param_t *index_param,gnomonisch_t *gnomonisch,datacol_t *datacol,metrik_t *metrik, az_data_t *az_data, az_data_t *az_bg, trans_table_t *trans_table);
void fill_configure_widgets (gnome_t *gnome, param_t *param, peaksearch_t *peaksearch, index_param_t *index_param,gnomonisch_t *gnomonisch,datacol_t *datacol,metrik_t *metrik);
void set_defaults (gnome_t *gnome, param_t *param, peaksearch_t *peaksearch, index_param_t *index_param,gnomonisch_t *gnomonisch,datacol_t *datacol,metrik_t *metrik, data_t *data, data_t *view_data, peaks_t *peaks, peaks_t *peaks_alle,trans_table_t *trans_table, az_data_t *az_data, az_data_t *az_bg);

// gnomonisch.c
int manuell_orient (param_t *param, peaks_t *peaks_alle,index_param_t *index_param, datacol_t *datacol, gnomonisch_t *gnomonisch, gnome_t *gnome, peaks_t *peaks, data_t *view_data, data_t *data);
void do_verfeinere_eine(int i, gnome_t *gnome, data_t *data, gnomonisch_t *gnomonisch, param_t *param);
void do_richtung_to_projection (double *vec, int num, gnomonisch_t *gnomonisch, data_t *data, gnome_t *gnome);
int do_projection (peaks_t *peaks, double *normal, double *om, data_t *data,param_t *param,gnome_t *gnome,gnomonisch_t *gnomonisch, data_t *view_data, index_param_t *index_param);
int calc_loesung(peaks_t *peaks_alle, peaks_t *peaks, double *normal, double *om, data_t *data, FILE *fp, loesung_t **loesung, int *anzahl_loesungen,gnome_t *gnome, param_t *param, index_param_t *index_param,data_t *view_data, gnomonisch_t *gnomonisch);
int integrate_lines (data_t *data,peaks_t *peaks_alle, peaks_t *peaks_on_gnomonisch, peaks_t *peaks, double *normal, FILE *fp, double *om, loesung_t **loesung, int *anzahl_loesungen, gnomonisch_t *gnomonisch, param_t *param, gnome_t *gnome, index_param_t *index_param,double *ub, data_t *view_data);
double check_mehrling2(peaks_t *peaks,double *om,param_t *param, gnomonisch_t *gnomonisch, gnome_t *gnome, peaks_t *peaks_alle, data_t *data, data_t *view_data, index_param_t *index_param);

//calibration.c
int do_axis_calibration(peaks_t *peaks, double *normal, double *om, data_t *data,param_t *param,gnome_t *gnome,gnomonisch_t *gnomonisch, data_t *view_data, index_param_t *index_param, datacol_t *datacol,  az_data_t *az_data);
int calibrate (datacol_t *datacol, peaks_t *peaks, peaks_t *peaks_alle, param_t *param, index_param_t *index_param, trans_table_t *trans_table, double *delta_A, double *delta_W);

// graphic.c
void make_canvas_cross (gnome_t *gnome, int *pos,int size, az_data_t *az_data,GnomeCanvasItem **cross, char *color);
void button_released_in_canvas(int i, gnome_t *gnome, param_t *param, datacol_t *datacol, az_data_t *az_data,az_data_t *az_bg, peaks_t *peaks_alle, trans_table_t *trans_table, index_param_t *index_param, object_list_t *object_list, peaksearch_t *peaksearch, double *pos, data_t *view_data,data_t *data, gnomonisch_t *gnomonisch);
void button_press_in_canvas(int button, gnome_t *gnome, param_t *param, datacol_t *datacol, az_data_t *az_data, az_data_t *az_bg, peaks_t *peaks_alle, trans_table_t *trans_table, index_param_t *index_param, object_list_t *object_list, peaksearch_t *peaksearch, double *pos, data_t *view_data);
void motion_in_canvas(gnome_t *gnome, param_t *param, datacol_t *datacol, data_t *view_data, index_param_t *index_param, double *button_pos, az_data_t *az_data, trans_table_t *trans_table);
void update_box(gnome_t *gnome, double *pos);
void make_canvas_box (gnome_t *gnome, double *pos,az_data_t *az_data);

// init.c
void init_integrate_variables (gnome_t *gnome, peaks_t *peaks,datacol_t *datacol,data_t *data,peaks_t *local_peaks,az_data_t *az_data,az_data_t *az_bg,trans_table_t *trans_table,data_t *view_data, int *start_platte, int *run_nr,char *dacayfile,FILE **fp2,int *anzahl_alle,param_t *param);
int init_integrate_files(peaksearch_t *peaksearch,datacol_t *datacol,gnome_t *gnome,char *hklfile,char *peakfile,char *objectfile,FILE **fp,param_t *param, char *decayname,char *logfile, FILE **log);
void init_phi_and_decay(char *bild_datei,param_t *param,int run,datacol_t *datacol,az_data_t *az_data,trans_table_t *trans_table,peaksearch_t *peaksearch,char *decayname,double **decay);

void
on_optionmenu6_changed(GtkButton       *button,
		       GObject *         user_data);
void
on_checkbutton21_toggled(GtkButton       *button,
			 GObject *         user_data) ;
void
on_optionmenu14_changed(GtkButton       *button,
		       GObject *         user_data);
void
on_checkbutton22_toggled(GtkButton       *button,
			 GObject *         user_data) ;
void
on_checkbutton23_toggled(GtkButton       *button,
			 GObject *         user_data) ;

#endif

